<template>
  <v-app>

    <v-navigation-drawer expand-on-hover rail permanent>
  
      <v-list density="compact" nav>
        <template v-for="item in navigation" :key="item.title">
          <v-list-item :href="item.href" :prepend-icon="item.icon" :title="item.title" exact v-if="showNav(item)"/>
        </template>
      </v-list>

      <v-divider></v-divider>

      <v-list v-if="user.email">
        <v-list-item
          :prepend-avatar="require('./assets/logo.png')"
          :title="user.name"
          :subtitle="user.email"
        >
        </v-list-item>
      </v-list>

      <v-list density="compact" nav>
        <v-list-item key="Login" @click="showLogin = true" prepend-icon="mdi-login" title="Login" exact v-if="!user.email"/>
        <v-list-item key="Logout" @click="showLogout = true" prepend-icon="mdi-logout" title="Logout" exact v-if="user.email"/>
      </v-list>

    </v-navigation-drawer>

    <v-main>
      <router-view :user="user"></router-view>
    </v-main>

    <Login @hideLogin="login" @loginSuccess="loginSuccess" :show="showLogin"/>
    <Logout @hideLogout="logout" @logoutSuccess="logoutSuccess" :user="user" :show="showLogout"/>

  </v-app>
</template>

<script>
import axios from 'axios'

import common from './mixins/common'

import Login from './components/Login.vue'
import Logout from './components/Logout.vue'

export default {
  name: 'pai2023',
  components: { Login, Logout },
  mixins: [ common ],
  methods: {
    login() { this.showLogin = false },
    logout() {
      this.showLogout = false
    },
    loginSuccess(user) {
      this.whoami(user)
    },
    logoutSuccess() {
      this.whoami({})
      this.$router.push('/')
    },
    whoami(user) {
      if(user) {
        this.user = user
        return
      }
      axios.get('/auth').then(
        (res) => {
          this.user = res.data
        }
      ).catch(
        () => { this.user = {} }
      )
    },
    showNav(item) {
      return this.checkIfInRole(this.user, item.roles)
    }
  },
  data() {
    return {
      navigation: [
          { title: 'Dashboard', icon: 'mdi-view-dashboard', href: '#/', roles: null },
          { title: 'Users', icon: 'mdi-account-multiple', href: '#/users', roles: [ 0, 1 ] }
      ],
      user: {},
      showLogin: false,
      showLogout: false
    }
  },
  mounted() { this.whoami() }
}
</script>

<style>
#app {
  font-family: Roboto, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: left;
  color: #2c3e50;
  margin: 30px 60px;
}
</style>